package com.njcn.energy.controller;

import com.njcn.common.pojo.annotation.OperateInfo;
import com.njcn.common.pojo.enums.common.LogEnum;
import com.njcn.common.pojo.enums.response.CommonResponseEnum;
import com.njcn.common.pojo.response.HttpResult;
import com.njcn.common.utils.HttpResultUtil;
import com.njcn.common.utils.LogUtil;
import com.njcn.energy.pojo.po.EleDo;
import com.njcn.energy.service.IEleDoService;
import com.njcn.web.controller.BaseController;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiOperation;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.*;

/**
 * 类的介绍：
 *
 * @author xuyang
 * @version 1.0.0
 * @createTime 2022/3/15 19:28
 */
@Slf4j
@RestController
@RequestMapping("/do")
@RequiredArgsConstructor
@Api(tags = "设备开出数据管理")
public class EleDoController extends BaseController {

    private final IEleDoService eleDoService;

    @PostMapping("/add")
    @OperateInfo(info = LogEnum.SYSTEM_COMMON)
    @ApiOperation("新增设备开出数据")
    @ApiImplicitParam(name = "eleDo", value = "设备开出数据", required = true)
    public HttpResult<Boolean> add(@RequestBody EleDo eleDo){
        String methodDescribe = getMethodDescribe("add");
        LogUtil.njcnDebug(log, "{}，设备开出数据：{}", methodDescribe, eleDo);
        boolean result = eleDoService.addDo(eleDo);
        return HttpResultUtil.assembleCommonResponseResult(CommonResponseEnum.SUCCESS, result, methodDescribe);
    }

    @PutMapping("/update")
    @OperateInfo(info = LogEnum.SYSTEM_COMMON)
    @ApiOperation("修改设备开出数据")
    @ApiImplicitParam(name = "eleDo", value = "设备开出数据", required = true)
    public HttpResult<Boolean> update(@RequestBody EleDo eleDo){
        String methodDescribe = getMethodDescribe("update");
        LogUtil.njcnDebug(log, "{}，设备开出数据：{}", methodDescribe, eleDo);
        boolean result = eleDoService.updateDo(eleDo);
        return HttpResultUtil.assembleCommonResponseResult(CommonResponseEnum.SUCCESS, result, methodDescribe);
    }

    @GetMapping("/findByName")
    @OperateInfo(info = LogEnum.SYSTEM_COMMON)
    @ApiOperation("根据名称查找数据")
    @ApiImplicitParam(name = "name", value = "名称", required = true)
    public HttpResult<EleDo> findByName(@RequestParam String name){
        String methodDescribe = getMethodDescribe("findByName");
        LogUtil.njcnDebug(log, "{}，名称为：{}", methodDescribe, name);
        EleDo eleDo = eleDoService.findByName(name);
        return HttpResultUtil.assembleCommonResponseResult(CommonResponseEnum.SUCCESS, eleDo, methodDescribe);
    }


}
